<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<ng-container>

  <ng-select
    (search)="updateDesksWithNewSearchTerm($event)"
    (clear)="onClear()"
    (scrollToEnd)="loadNextPageOfDesks()"
    [(ngModel)]="multiple ? desks : desks[0]"
    (change)="onDeskSelectionChanged($event)"
    [notFoundText]="commonMessages.NO_DESK_FOUND"
    [multiple]="multiple"
    [clearable]="clearable"
    [clearAllText]="commonMessages.CLEAR"
    [disabled]="disabled"
    [searchFn]="filterDesks"
    [compareWith]="compareByIdFn"
    bindLabel="name"
    class="input-group ls-select w-100"
    id="validator"
    name="validator"
    [placeholder]="multiple ? 'Choisissez des bureaux...' : 'Choisissez un bureau...'"
    selectOnTab>


    <!-- Hopefully a temporary specific subcase : display only the emitter -->
    <ng-container *ngIf="genericValidatorsAvailable && genericEmitterOnly">
      <ng-option
        class="overflow-hidden text-overflow-ellipsis"
        [value]="genericWorkflowActors.EMITTER">
        <app-smart-shrink
          [text]="genericWorkflowActors.EMITTER.name | namePipe">
        </app-smart-shrink>
      </ng-option>
    </ng-container>


    <ng-container *ngIf="genericValidatorsAvailable && !genericEmitterOnly">
      <ng-option
        class="overflow-hidden text-overflow-ellipsis"
        *ngFor="let validator of genericWorkflowActors | keyvalue"
        [value]="genericWorkflowActors[validator.key]">
        <app-smart-shrink
          [text]="genericWorkflowActors[validator.key].name | namePipe">
        </app-smart-shrink>
      </ng-option>
    </ng-container>

    <ng-option
      class="overflow-hidden text-overflow-ellipsis"
      *ngFor="let validator of availableValidators"
      [value]="validator">
      <app-smart-shrink
        [text]="validator.name | namePipe">
      </app-smart-shrink>
    </ng-option>

  </ng-select>

</ng-container>
